'use strict';Object.defineProperty(exports,"__esModule",{value:true});var _extends=Object.assign||function(target){for(var i=1;i<arguments.length;i++){var source=arguments[i];for(var key in source){if(Object.prototype.hasOwnProperty.call(source,key)){target[key]=source[key];}}}return target;};exports.fetchSchema=fetchSchema;exports.readSchema=readSchema;exports.saveSchema=saveSchema;exports.compareSchema=compareSchema;var _util=require('util');var _util2=_interopRequireDefault(_util);var _fs=require('fs');var _fs2=_interopRequireDefault(_fs);var _introspectionQuery=require('graphql/utilities/introspectionQuery');var _axios=require('axios');var _axios2=_interopRequireDefault(_axios);var _objects=require('./objects');function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj};}var schema=void 0;function fetchSchema(path){return importSchema(path).then(function(response){return parseSchema(response);});}function readSchema(schemaPath){return new Promise(function(resolve,reject){_fs2.default.readFile(schemaPath,"utf8",function(err,data){if(err)reject(err);resolve(JSON.parse(data.toString()));});});}function saveSchema(schema,savePath){return new Promise(function(resolve,reject){_fs2.default.writeFile(savePath,JSON.stringify(schema),function(err){if(err)reject(err);resolve(savePath);});});}function compareSchema(schema1,schema2){return generateStats(schema2,schema1);}function importSchema(path){return(0,_axios2.default)({method:"POST",url:path,data:{query:_introspectionQuery.introspectionQuery},responseType:'json'}).then(function(response){schema=response.data.data;return schema;}).catch(function(error){console.error(error);throw error;});}function parseSchema(savePath){return{queries:parseRootSchema('Query'),mutations:parseRootSchema('Mutation'),objects:parseObjectsSchema('OBJECT'),inputObjects:parseObjectsSchema('INPUT_OBJECT')};}function parseRootSchema(rootQueryName){var rootQueries=[];schema.__schema.types.forEach(function(rootQuery){if(rootQuery.name===rootQueryName){var rootQueryFields=rootQuery.fields;rootQueryFields.map(function(rootQueryField){rootQueries.push((0,_objects.parseQueryObject)(schema,rootQueryField));});}});return rootQueries;}function parseObjectsSchema(){var kind=arguments.length>0&&arguments[0]!==undefined?arguments[0]:'OBJECT';var objects=(0,_objects.getObjects)(schema,kind).filter(function(object){return!object.name.startsWith('__')&&object.name!=='Query'&&object.name!=='Mutation';});objects=objects.map(function(object){return(0,_objects.parseObject)(schema,object,true);});return objects;}function generateStats(schema){var previousSchema=arguments.length>1&&arguments[1]!==undefined?arguments[1]:null;var lengths={queries:schema.queries.length,mutations:schema.mutations.length,objects:schema.objects.length,inputObjects:schema.inputObjects.length};if(previousSchema){lengths=_extends({},lengths,{previousQueries:previousSchema.queries.length,previousMutations:previousSchema.mutations.length,previousObjects:previousSchema.objects.length,previousInputObjects:previousSchema.inputObjects.length});return{queries:generateStatText(lengths.queries,lengths.queries-lengths.previousQueries),mutations:generateStatText(lengths.mutations,lengths.mutations-lengths.previousMutations),objects:generateStatText(lengths.objects,lengths.objects-lengths.previousObjects),inputObjects:generateStatText(lengths.inputObjects,lengths.inputObjects-lengths.previousInputObjects)};}else{return{queries:generateStatText(lengths.queries,lengths.queries),mutations:generateStatText(lengths.mutations,lengths.mutations),objects:generateStatText(lengths.objects,lengths.objects),inputObjects:generateStatText(lengths.inputObjects,lengths.inputObjects)};}}function generateStatText(length,difference){var text='';if(difference>=0){text=length+' (+'+difference+')';}else if(difference<0){text=length+' (-'+difference+')';}return text;}